## kdiskmark 2.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(kdiskmark VERSION 2.1.1 LANGUAGES CXX)

set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/JonMagon/KDiskMark")
set(CMAKE_PROJECT_DESCRIPTION "A simple open source disk benchmark tool for Linux distros")

set(APPLICATION_NAME "KDiskMark")
set(DESKTOP_FILE kdiskmark.desktop)

configure_file(src/cmake.h.in cmake.h)
include_directories(${PROJECT_BINARY_BIN})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CPACK_PACKAGE_VENDOR ${APPLICATION_NAME})
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${APPLICATION_NAME})
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_CONTACT jonmagon@gmail.com)
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE)

set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_PACKAGE_GENERATE_SHLIBS_POLICY >=)
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
set(CPACK_RPM_PACKAGE_LICENSE GPLv3)
set(CPACK_RPM_PACKAGE_GROUP Applications/System)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "fio (>= 3.1)")
set(CPACK_RPM_COMPRESSION_TYPE lzma)
set(CPACK_NSIS_DISPLAY_NAME ${APPLICATION_NAME})

find_package(Qt5 COMPONENTS Widgets LinguistTools REQUIRED)

find_package(ECM REQUIRED NO_MODULE)
list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(CPack)
include(GNUInstallDirs)
include(ECMInstallIcons)

set(TS_FILES
    data/translations/${PROJECT_NAME}_cs_CZ.ts
    data/translations/${PROJECT_NAME}_de_DE.ts
    data/translations/${PROJECT_NAME}_es_MX.ts
    data/translations/${PROJECT_NAME}_fr_FR.ts
    data/translations/${PROJECT_NAME}_it_IT.ts
    data/translations/${PROJECT_NAME}_pl_PL.ts
    data/translations/${PROJECT_NAME}_pt_BR.ts
    data/translations/${PROJECT_NAME}_ru_RU.ts
    data/translations/${PROJECT_NAME}_sk_SK.ts
    data/translations/${PROJECT_NAME}_uk_UA.ts
    data/translations/${PROJECT_NAME}_zh_CN.ts
)

qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})

add_executable(${PROJECT_NAME}
    ${QM_FILES}
    data/icons/flags/flags.qrc
    src/main.cpp
    src/mainwindow.cpp
    src/mainwindow.h
    src/mainwindow.ui
    src/benchmark.cpp
    src/benchmark.h
    src/about.cpp
    src/about.h
    src/about.ui
    src/appsettings.h
    src/appsettings.cpp
    src/settings.cpp
    src/settings.h
    src/settings.ui
    src/global.cpp
    src/global.h
    src/diskdriveinfo.cpp
    src/diskdriveinfo.h
)

target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Widgets)

set(APP_ICONS
    data/icons/16-apps-kdiskmark.png
    data/icons/24-apps-kdiskmark.png
    data/icons/32-apps-kdiskmark.png
    data/icons/48-apps-kdiskmark.png
    data/icons/64-apps-kdiskmark.png
    data/icons/128-apps-kdiskmark.png
    data/icons/256-apps-kdiskmark.png
    data/icons/512-apps-kdiskmark.png
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/translations)
install(FILES data/${DESKTOP_FILE} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

ecm_install_icons(ICONS ${APP_ICONS} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons)

=== debian/changelog ===
kdiskmark (2.1.1-3~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.
  * Rename upstream tarball to .orig.
  * Change source/format to quilt.
  * Rules: add override_dh_strip: dh_strip --no-automatic-dbgsym.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sat, 06 Feb 2021 16:56:35 -0500

kdiskmark (2.1.1-3) groovy; urgency=medium

  * No-change rebuild for groovy
  
 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Thu, 28 Jan 2021 12:41:32 +0300
 

kdiskmark (2.1.1-2) bionic; urgency=medium

  * No-change rebuild for bionic
  
 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Thu, 28 Jan 2021 12:38:16 +0300
 

kdiskmark (2.1.1-1) focal; urgency=medium

  * Fix directory selection
  
 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Thu, 28 Jan 2021 12:33:40 +0300

kdiskmark (2.1.0-3) groovy; urgency=medium

  * No-change rebuild for groovy.
  
 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Thu, 31 Dec 2020 14:45:18 +0300
 

kdiskmark (2.1.0-2) bionic; urgency=medium

  * No-change rebuild for bionic.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Thu, 31 Dec 2020 14:31:05 +0300
 

kdiskmark (2.1.0-1) focal; urgency=medium

  * Spanish (Mexico), Slovak, Polish, Ukrainian localization
  * Allow selecting the UI language: Help > Language
  * Prevent adding the same directory multiple times
  * Hide status bar
  * Fix directory selection dialog
  * Fix benchmark won't run

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Thu, 31 Dec 2020 14:31:05 +0300
 

kdiskmark (2.0.0-build3) groovy; urgency=medium

  * No-change rebuild for groovy.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Sat, 24 Oct 2020 12:14:56 +0300
 

kdiskmark (2.0.0-build2) bionic; urgency=medium

  * No-change rebuild for bionic.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Sat, 24 Oct 2020 12:13:08 +0300
 

kdiskmark (2.0.0) focal; urgency=medium

  * Performance profiles.
  * Column with bars of mixed tests (mixed profile).
  * Possibility to specify a test-directory manually.
  * French translation.
  * Italian translation.
  * Portuguese (Brazilian) translation.
  * Chinese (Simplified) translation.
  * Removed 20-px icon.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Sat, 24 Oct 2020 11:19:19 +0300
 

kdiskmark (1.6.2~groovy) groovy; urgency=medium

  * No-change rebuild for groovy.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Fri, 23 Oct 2020 16:38:24 +0300
 

kdiskmark (1.6.2~bionic) bionic; urgency=medium

  * No-change rebuild try for bionic.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Fri, 23 Oct 2020 15:47:12 +0300

kdiskmark (1.6.2) focal; urgency=medium

  * Scan all non-readonly devices in /dev

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Fri, 18 Sep 2020 12:05:03 +0300

kdiskmark (1.6.1) focal; urgency=medium

  * Czech localization
  * Encrypted devices detection
  * Loops are separated in the app instead of fio
  * Fix indents in the text report

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Wed, 16 Sep 2020 12:12:47 +0300
 

kdiskmark (1.6.0) focal; urgency=medium

  * Initial Release.

 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Mon, 07 Sep 2020 14:01:56 +0300

=== debian/control ===
Source: kdiskmark
Section: devel
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Dmitry Ilyich Sidorov <jonmagon@gmail.com>
Build-Depends: debhelper-compat (= 11), cmake, extra-cmake-modules, qttools5-dev
Standards-Version: 4.4.1
Homepage: https://github.com/JonMagon/KDiskMark
#Vcs-Browser: https://salsa.debian.org/debian/kdiskmark
#Vcs-Git: https://salsa.debian.org/debian/kdiskmark.git

Package: kdiskmark
Architecture: any
Depends: fio (>= 3.1), ${shlibs:Depends}, ${misc:Depends}
Description: A simple open source disk benchmark tool for Linux distros

## kdiskmark 2.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(kdiskmark VERSION 2.1.1 LANGUAGES CXX)
+project(kdiskmark VERSION 2.2.0 LANGUAGES CXX)
 
 set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/JonMagon/KDiskMark")
 set(CMAKE_PROJECT_DESCRIPTION "A simple open source disk benchmark tool for Linux distros")
@@ -44,6 +44,9 @@
 include(CPack)
 include(GNUInstallDirs)
 include(ECMInstallIcons)
+include(KDEInstallDirs)
+
+find_package(KF5Auth REQUIRED NO_MODULE)
 
 set(TS_FILES
     data/translations/${PROJECT_NAME}_cs_CZ.ts
@@ -84,7 +87,7 @@
     src/diskdriveinfo.h
 )
 
-target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Widgets)
+target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Widgets KF5::Auth)
 
 set(APP_ICONS
     data/icons/16-apps-kdiskmark.png
@@ -102,3 +105,16 @@
 install(FILES data/${DESKTOP_FILE} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
 
 ecm_install_icons(ICONS ${APP_ICONS} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons)
+
+# Helper
+
+add_executable(${PROJECT_NAME}_helper
+    src/helper.cpp
+    src/helper.h
+)
+
+target_link_libraries(${PROJECT_NAME}_helper KF5::Auth)
+
+install(TARGETS ${PROJECT_NAME}_helper DESTINATION ${KAUTH_HELPER_INSTALL_DIR})
+kauth_install_helper_files(${PROJECT_NAME}_helper org.jonmagon.kdiskmark root)
+kauth_install_actions(org.jonmagon.kdiskmark data/kdiskmark.actions)

=== debian/changelog ===
kdiskmark (2.2.0-3~mx21+1) mx; urgency=medium

  * Repackage of upstream release for MX-21, no changes.

 -- SwampRabbit <maintainer@mepiscommunity.org>  Mon, 29 Mar 2021 15:41:07 -0400

kdiskmark (2.2.0-3~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 22 Mar 2021 12:10:48 -0400

kdiskmark (2.2.0-1) focal; urgency=medium

  * The ability to drop pagecache before doing a test job (using K5Auth)
  
 -- Dmitry Ilyich Sidorov <jonmagon@gmail.com>  Fri, 19 Feb 2021 21:21:12 +0300

## kdiskmark 2.2.0+git20210604

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,6 +36,9 @@
 set(CPACK_RPM_COMPRESSION_TYPE lzma)
 set(CPACK_NSIS_DISPLAY_NAME ${APPLICATION_NAME})
 
+option(BUILD_WITH_PAGECACHE_CLEARING_SUPPORT "Cache clearing functionality" ON)
+option(PERFORM_PAGECACHE_CLEARING_USING_KF5AUTH "Determines whether a helper will be built" ON)
+
 find_package(Qt5 COMPONENTS Widgets LinguistTools REQUIRED)
 
 find_package(ECM REQUIRED NO_MODULE)
@@ -46,13 +49,12 @@
 include(ECMInstallIcons)
 include(KDEInstallDirs)
 
-find_package(KF5Auth REQUIRED NO_MODULE)
-
 set(TS_FILES
     data/translations/${PROJECT_NAME}_cs_CZ.ts
     data/translations/${PROJECT_NAME}_de_DE.ts
     data/translations/${PROJECT_NAME}_es_MX.ts
     data/translations/${PROJECT_NAME}_fr_FR.ts
+    data/translations/${PROJECT_NAME}_hi_IN.ts
     data/translations/${PROJECT_NAME}_it_IT.ts
     data/translations/${PROJECT_NAME}_pl_PL.ts
     data/translations/${PROJECT_NAME}_pt_BR.ts
@@ -87,7 +89,16 @@
     src/diskdriveinfo.h
 )
 
-target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Widgets KF5::Auth)
+target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Widgets)
+
+if(BUILD_WITH_PAGECACHE_CLEARING_SUPPORT)
+    target_compile_definitions(${PROJECT_NAME} PRIVATE BUILD_WITH_PAGECACHE_CLEARING_SUPPORT)
+    if(PERFORM_PAGECACHE_CLEARING_USING_KF5AUTH)
+        target_compile_definitions(${PROJECT_NAME} PRIVATE PERFORM_PAGECACHE_CLEARING_USING_KF5AUTH)
+        find_package(KF5Auth REQUIRED NO_MODULE)
+        target_link_libraries(${PROJECT_NAME} PRIVATE KF5::Auth)
+    endif()
+endif()
 
 set(APP_ICONS
     data/icons/16-apps-kdiskmark.png
@@ -108,13 +119,15 @@
 
 # Helper
 
-add_executable(${PROJECT_NAME}_helper
-    src/helper.cpp
-    src/helper.h
-)
+if(BUILD_WITH_PAGECACHE_CLEARING_SUPPORT AND PERFORM_PAGECACHE_CLEARING_USING_KF5AUTH)
+    add_executable(${PROJECT_NAME}_helper
+        src/helper.cpp
+        src/helper.h
+    )
 
-target_link_libraries(${PROJECT_NAME}_helper KF5::Auth)
+    target_link_libraries(${PROJECT_NAME}_helper KF5::Auth)
 
-install(TARGETS ${PROJECT_NAME}_helper DESTINATION ${KAUTH_HELPER_INSTALL_DIR})
-kauth_install_helper_files(${PROJECT_NAME}_helper org.jonmagon.kdiskmark root)
-kauth_install_actions(org.jonmagon.kdiskmark data/kdiskmark.actions)
+    install(TARGETS ${PROJECT_NAME}_helper DESTINATION ${KAUTH_HELPER_INSTALL_DIR})
+    kauth_install_helper_files(${PROJECT_NAME}_helper org.jonmagon.kdiskmark root)
+    kauth_install_actions(org.jonmagon.kdiskmark data/kdiskmark.actions)
+endif()

=== debian/changelog ===
kdiskmark (2.2.0+git20210604-1~mx21+1) mx; urgency=medium

  * Initial packaging of upstream GitHub master for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 11 Jul 2021 14:53:03 -0400

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
 XSBC-Original-Maintainer: Dmitry Ilyich Sidorov <jonmagon@gmail.com>
-Build-Depends: debhelper-compat (= 11), cmake, extra-cmake-modules, qttools5-dev
+Build-Depends: debhelper-compat (= 11), cmake, extra-cmake-modules, qttools5-dev, libkf5auth-dev
 Standards-Version: 4.4.1
 Homepage: https://github.com/JonMagon/KDiskMark
 #Vcs-Browser: https://salsa.debian.org/debian/kdiskmark

## kdiskmark 2.2.1

=== debian/changelog ===
kdiskmark (2.2.1-1~mx21+1) mx; urgency=medium

  * Initial packaging for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 22 Jul 2021 10:43:04 -0400

kdiskmark (2.2.0+git20210604-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream GitHub master for MX-19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Sun, 11 Jul 2021 14:53:03 -0400

## kdiskmark 2.3.0+git20211102

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(kdiskmark VERSION 2.2.0 LANGUAGES CXX)
+project(kdiskmark VERSION 2.3.0 LANGUAGES CXX)
 
 set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/JonMagon/KDiskMark")
 set(CMAKE_PROJECT_DESCRIPTION "A simple open source disk benchmark tool for Linux distros")

=== debian/changelog ===
kdiskmark (2.3.0+git20211102-1~mx21+2) mx; urgency=medium

  * Initial packaging of upstream GitHub master for MX-21.
  * Update package description with more info.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Thu, 02 Dec 2021 14:20:46 -0500

=== debian/control ===
--- 
+++ 
@@ -12,4 +12,11 @@
 Package: kdiskmark
 Architecture: any
 Depends: fio (>= 3.1), ${shlibs:Depends}, ${misc:Depends}
-Description: A simple open source disk benchmark tool for Linux distros
+Description: A simple open source disk benchmark tool
+ KDiskMark is an HDD and SSD benchmark tool with a very friendly graphical user
+  interface. 
+ .
+ Features:
+  - Configurable block size, queues, and threads count for each test
+  - Many languages support
+  - Report generation

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)

## kdiskmark 3.1.3%2Bds

=== debian/changelog ===
kdiskmark (3.1.3+ds-4build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:10:46 +1100

kdiskmark (3.1.3+ds-4build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:54:11 +0000

kdiskmark (3.1.3+ds-4) unstable; urgency=medium

  * d/control: update short description. (Closes: #1052266)
  * d/clean: added, fix source after build problem. (Closes: #1046455)

 -- Gürkan Myczko <tar@debian.org>  Wed, 24 Jan 2024 12:41:28 +0100

kdiskmark (3.1.3+ds-3) unstable; urgency=medium

  * d/control: add fio to Depends.

 -- Gürkan Myczko <tar@debian.org>  Fri, 16 Jun 2023 13:00:54 +0200

kdiskmark (3.1.3+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * d/watch: updated.

 -- Gürkan Myczko <tar@debian.org>  Wed, 17 May 2023 15:36:12 +0200

kdiskmark (3.1.3+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #973684)

 -- Gürkan Myczko <tar@debian.org>  Tue, 09 May 2023 19:50:34 +0200

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

## kdiskmark 3.1.3+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(kdiskmark VERSION 3.1.3 LANGUAGES CXX)

set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/JonMagon/KDiskMark")
set(CMAKE_PROJECT_DESCRIPTION "A simple open source disk benchmark tool for Linux distros")

set(APPLICATION_NAME "KDiskMark")
set(DESKTOP_FILE kdiskmark.desktop)

configure_file(src/cmake.h.in cmake.h)
include_directories(${PROJECT_BINARY_BIN})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CPACK_PACKAGE_VENDOR ${APPLICATION_NAME})
set(CPACK_PACKAGE_INSTALL_DIRECTORY ${APPLICATION_NAME})
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
set(CPACK_PACKAGE_CONTACT jonmagon@gmail.com)
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE)

set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_PACKAGE_GENERATE_SHLIBS_POLICY >=)
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
set(CPACK_RPM_PACKAGE_LICENSE GPLv3)
set(CPACK_RPM_PACKAGE_GROUP Applications/System)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "fio (>= 3.1)")
set(CPACK_RPM_COMPRESSION_TYPE lzma)
set(CPACK_NSIS_DISPLAY_NAME ${APPLICATION_NAME})

set(QAPPLICATION_CLASS QApplication)
add_subdirectory(src/singleapplication)

find_package(Qt5 COMPONENTS Widgets LinguistTools DBus REQUIRED)

find_package(ECM REQUIRED NO_MODULE)
list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(CPack)
include(GNUInstallDirs)
include(ECMInstallIcons)
include(ECMConfiguredInstall)
include(KDEInstallDirs)

find_package(PolkitQt5-1 REQUIRED)

set(helper_interface_xml dev.jonmagon.kdiskmark.helperinterface.xml)

qt5_generate_dbus_interface(
    src/helper.h
    ${helper_interface_xml}
    OPTIONS -a
)

qt5_add_dbus_interface(HelperInterface_SRCS ${CMAKE_CURRENT_BINARY_DIR}/${helper_interface_xml} helper_interface)

set(TS_FILES
    data/translations/${PROJECT_NAME}_cs_CZ.ts
    data/translations/${PROJECT_NAME}_de_DE.ts
    data/translations/${PROJECT_NAME}_es_MX.ts
    data/translations/${PROJECT_NAME}_fr_FR.ts
    data/translations/${PROJECT_NAME}_hi_IN.ts
    data/translations/${PROJECT_NAME}_hu_HU.ts
    data/translations/${PROJECT_NAME}_it_IT.ts
    data/translations/${PROJECT_NAME}_ja_JP.ts
    data/translations/${PROJECT_NAME}_pl_PL.ts
    data/translations/${PROJECT_NAME}_pt_BR.ts
    data/translations/${PROJECT_NAME}_ru_RU.ts
    data/translations/${PROJECT_NAME}_sk_SK.ts
    data/translations/${PROJECT_NAME}_sv_SE.ts
    data/translations/${PROJECT_NAME}_tr_TR.ts
    data/translations/${PROJECT_NAME}_uk_UA.ts
    data/translations/${PROJECT_NAME}_zh_CN.ts
)

qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})

add_executable(${PROJECT_NAME}
    ${QM_FILES}
    data/icons/flags/flags.qrc
    ${HelperInterface_SRCS}
    src/main.cpp
    src/mainwindow.h
    src/mainwindow.cpp
    src/mainwindow.ui
    src/storageitemdelegate.h
    src/storageitemdelegate.cpp
    src/benchmark.h
    src/benchmark.cpp
    src/about.h
    src/about.cpp
    src/about.ui
    src/appsettings.h
    src/appsettings.cpp
    src/settings.h
    src/settings.cpp
    src/settings.ui
    src/global.h
    src/global.cpp
    src/diskdriveinfo.h
    src/diskdriveinfo.cpp
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    SingleApplication::SingleApplication
    Qt5::Widgets
    Qt5::DBus
)

set(APP_ICONS
    data/icons/16-apps-kdiskmark.png
    data/icons/24-apps-kdiskmark.png
    data/icons/32-apps-kdiskmark.png
    data/icons/48-apps-kdiskmark.png
    data/icons/64-apps-kdiskmark.png
    data/icons/128-apps-kdiskmark.png
    data/icons/256-apps-kdiskmark.png
    data/icons/512-apps-kdiskmark.png
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/translations)
install(FILES data/${DESKTOP_FILE} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)

ecm_install_icons(ICONS ${APP_ICONS} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons)

# Helper
add_executable(${PROJECT_NAME}_helper
    src/helper.cpp
    src/helper.h
)

target_link_libraries(${PROJECT_NAME}_helper
    Qt5::DBus
    PolkitQt5-1::Core
)

install(TARGETS ${PROJECT_NAME}_helper DESTINATION ${KDE_INSTALL_LIBEXECDIR})
install(FILES data/dev.jonmagon.kdiskmark.helperinterface.conf DESTINATION ${KDE_INSTALL_DBUSDIR}/system.d)

install(FILES data/dev.jonmagon.kdiskmark.helper.policy DESTINATION ${POLKITQT-1_POLICY_FILES_INSTALL_DIR})
ecm_install_configured_files(
    INPUT data/dev.jonmagon.kdiskmark.helperinterface.service.in
    DESTINATION ${KDE_INSTALL_DBUSDIR}/system-services
)

=== src/singleapplication/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12.0)

project(SingleApplication LANGUAGES CXX DESCRIPTION "Replacement for QtSingleApplication")

set(CMAKE_AUTOMOC ON)

add_library(${PROJECT_NAME} STATIC
    singleapplication.cpp
    singleapplication_p.cpp
)
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

if(NOT QT_DEFAULT_MAJOR_VERSION)
    set(QT_DEFAULT_MAJOR_VERSION 5 CACHE STRING "Qt version to use (5 or 6), defaults to 5")
endif()

# Find dependencies
set(QT_COMPONENTS Core Network)
set(QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Core Qt${QT_DEFAULT_MAJOR_VERSION}::Network)

if(QAPPLICATION_CLASS STREQUAL QApplication)
    list(APPEND QT_COMPONENTS Widgets)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Widgets)
elseif(QAPPLICATION_CLASS STREQUAL QGuiApplication)
    list(APPEND QT_COMPONENTS Gui)
    list(APPEND QT_LIBRARIES Qt${QT_DEFAULT_MAJOR_VERSION}::Gui)
else()
    set(QAPPLICATION_CLASS QCoreApplication)
endif()

find_package(Qt${QT_DEFAULT_MAJOR_VERSION} COMPONENTS ${QT_COMPONENTS} REQUIRED)

option(SINGLEAPPLICATION_DOCUMENTATION "Generate Doxygen documentation" OFF)
if(SINGLEAPPLICATION_DOCUMENTATION)
    find_package(Doxygen)
endif()

target_link_libraries(${PROJECT_NAME} PUBLIC ${QT_LIBRARIES})

if(WIN32)
    target_link_libraries(${PROJECT_NAME} PRIVATE advapi32)
endif()

target_compile_definitions(${PROJECT_NAME} PUBLIC QAPPLICATION_CLASS=${QAPPLICATION_CLASS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_compile_definitions(${PROJECT_NAME} PRIVATE
    QT_NO_CAST_TO_ASCII
    QT_NO_CAST_FROM_ASCII
    QT_NO_URL_CAST_FROM_STRING
    QT_NO_CAST_FROM_BYTEARRAY
    QT_USE_QSTRINGBUILDER
    QT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    QT_NO_KEYWORDS
    QT_NO_FOREACH
)

if(DOXYGEN_FOUND)
    # Doxygen theme
    include(FetchContent)
    FetchContent_Declare(DoxygenAwesome
        GIT_REPOSITORY https://github.com/jothepro/doxygen-awesome-css
        GIT_TAG 4cd62308d825fe0396d2f66ffbab45d0e247724c # 2.0.3
    )
    FetchContent_MakeAvailable(DoxygenAwesome)
    FetchContent_GetProperties(DoxygenAwesome SOURCE_DIR DoxygenAwesome_SOURCE_DIR)

    set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)
    set(DOXYGEN_GENERATE_TREEVIEW YES)
    set(DOXYGEN_HTML_HEADER ${DoxygenAwesome_SOURCE_DIR}/doxygen-custom/header.html)
    set(DOXYGEN_HTML_EXTRA_STYLESHEET ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome.css)
    set(DOXYGEN_HTML_EXTRA_FILES
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-fragment-copy-button.js
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-paragraph-link.js
        ${DoxygenAwesome_SOURCE_DIR}/doxygen-awesome-darkmode-toggle.js
    )

    doxygen_add_docs(${PROJECT_NAME}Documentation
        singleapplication.h
        CHANGELOG.md
        Windows.md
        README.md
    )
endif()

=== debian/changelog ===
kdiskmark (3.1.3+ds-5~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 26 Jul 2025 10:28:49 -0700

kdiskmark (3.1.3+ds-5) unstable; urgency=medium

  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Tue, 16 Jul 2024 14:33:31 +0000

=== debian/control ===
Source: kdiskmark
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Dmitry Ilyich Sidorov <jonmagon@gmail.com>
Uploaders: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               extra-cmake-modules,
               libaio-dev,
               libpolkit-qt5-1-dev,
               qttools5-dev
Standards-Version: 4.7.0
Homepage: https://github.com/JonMagon/KDiskMark
Vcs-Browser: https://salsa.debian.org/debian/kdiskmark
Vcs-Git: https://salsa.debian.org/debian/kdiskmark.git

Package: kdiskmark
Architecture: any
Depends: fio, ${misc:Depends}, ${shlibs:Depends}
Description: simple disk benchmark tool
 This is an HDD and SSD benchmark tool with a very friendly
 graphical user interface. KDiskMark with its presets and powerful
 GUI calls Flexible I/O Tester and handles the output to provide an
 easy to view and interpret comprehensive benchmark result.

## kdiskmark 3.1.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(kdiskmark VERSION 3.1.3 LANGUAGES CXX)
+project(kdiskmark VERSION 3.1.4 LANGUAGES CXX)
 
 set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/JonMagon/KDiskMark")
 set(CMAKE_PROJECT_DESCRIPTION "A simple open source disk benchmark tool for Linux distros")
@@ -71,6 +71,7 @@
     data/translations/${PROJECT_NAME}_hu_HU.ts
     data/translations/${PROJECT_NAME}_it_IT.ts
     data/translations/${PROJECT_NAME}_ja_JP.ts
+    data/translations/${PROJECT_NAME}_nl_NL.ts
     data/translations/${PROJECT_NAME}_pl_PL.ts
     data/translations/${PROJECT_NAME}_pt_BR.ts
     data/translations/${PROJECT_NAME}_ru_RU.ts
@@ -127,7 +128,7 @@
 )
 
 install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
-install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/translations)
+install(FILES ${QM_FILES} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/${PROJECT_NAME}/${PROJECT_NAME}/translations)
 install(FILES data/${DESKTOP_FILE} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/applications)
 
 ecm_install_icons(ICONS ${APP_ICONS} DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/icons)

=== debian/changelog ===
kdiskmark (3.1.4-1) UNRELEASED; urgency=medium

  * Initial release. (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- pavroo <pavroo@onet.eu>  Mon, 19 Jun 2023 20:24:00 +0200

=== debian/control ===
Source: kdiskmark
Section: devel
Priority: optional
Maintainer: pavroo <pavroo@onet.eu>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Standards-Version: 4.6.2
Homepage: <insert the upstream URL, if relevant>
#Vcs-Browser: https://salsa.debian.org/debian/kdiskmark
#Vcs-Git: https://salsa.debian.org/debian/kdiskmark.git

Package: kdiskmark
Architecture: all
Depends:
 ${misc:Depends},
Description: <insert up to 60 chars description>
 <Insert long description, indented with spaces.>

## kdiskmark 3.2.0%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 
-project(kdiskmark VERSION 3.1.4 LANGUAGES CXX)
+project(kdiskmark VERSION 3.2.0 LANGUAGES CXX)
 
 set(CMAKE_PROJECT_HOMEPAGE_URL "https://github.com/JonMagon/KDiskMark")
 set(CMAKE_PROJECT_DESCRIPTION "A simple open source disk benchmark tool for Linux distros")
@@ -12,6 +12,20 @@
 include_directories(${PROJECT_BINARY_BIN})
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+option(USE_QT5 "Use Qt5 instead of Qt6" OFF)
+
+if(USE_QT5)
+    find_package(Qt5 COMPONENTS Widgets LinguistTools DBus REQUIRED)
+    find_package(PolkitQt5-1 REQUIRED)
+    set(QT_LIBS Qt5::Widgets Qt5::DBus)
+    set(POLKIT_LIB PolkitQt5-1::Core)
+else()
+    find_package(Qt6 COMPONENTS Widgets LinguistTools DBus REQUIRED)
+    find_package(PolkitQt6-1 REQUIRED)
+    set(QT_LIBS Qt6::Widgets Qt6::DBus)
+    set(POLKIT_LIB PolkitQt6-1::Core)
+endif()
 
 set(CMAKE_AUTOUIC ON)
 set(CMAKE_AUTOMOC ON)
@@ -32,14 +46,13 @@
 set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
 set(CPACK_RPM_PACKAGE_LICENSE GPLv3)
 set(CPACK_RPM_PACKAGE_GROUP Applications/System)
+set(CPACK_RPM_PACKAGE_REQUIRES "fio >= 3.1")
 set(CPACK_DEBIAN_PACKAGE_DEPENDS "fio (>= 3.1)")
 set(CPACK_RPM_COMPRESSION_TYPE lzma)
 set(CPACK_NSIS_DISPLAY_NAME ${APPLICATION_NAME})
 
 set(QAPPLICATION_CLASS QApplication)
 add_subdirectory(src/singleapplication)
-
-find_package(Qt5 COMPONENTS Widgets LinguistTools DBus REQUIRED)
 
 find_package(ECM REQUIRED NO_MODULE)
 list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
@@ -50,22 +63,31 @@
 include(ECMConfiguredInstall)
 include(KDEInstallDirs)
 
-find_package(PolkitQt5-1 REQUIRED)
-
 set(helper_interface_xml dev.jonmagon.kdiskmark.helperinterface.xml)
 
-qt5_generate_dbus_interface(
-    src/helper.h
-    ${helper_interface_xml}
-    OPTIONS -a
-)
-
-qt5_add_dbus_interface(HelperInterface_SRCS ${CMAKE_CURRENT_BINARY_DIR}/${helper_interface_xml} helper_interface)
+# Generate DBus Interface
+if(USE_QT5)
+    qt5_generate_dbus_interface(
+        src/helper.h
+        ${helper_interface_xml}
+        OPTIONS -a
+    )
+    qt5_add_dbus_interface(HelperInterface_SRCS ${CMAKE_CURRENT_BINARY_DIR}/${helper_interface_xml} helper_interface)
+else()
+    qt6_generate_dbus_interface(
+        src/helper.h
+        ${helper_interface_xml}
+        OPTIONS -a
+    )
+    qt6_add_dbus_interface(HelperInterface_SRCS ${CMAKE_CURRENT_BINARY_DIR}/${helper_interface_xml} helper_interface)
+endif()
 
 set(TS_FILES
     data/translations/${PROJECT_NAME}_cs_CZ.ts
     data/translations/${PROJECT_NAME}_de_DE.ts
+    data/translations/${PROJECT_NAME}_es_ES.ts
     data/translations/${PROJECT_NAME}_es_MX.ts
+    data/translations/${PROJECT_NAME}_fi_FI.ts
     data/translations/${PROJECT_NAME}_fr_FR.ts
     data/translations/${PROJECT_NAME}_hi_IN.ts
     data/translations/${PROJECT_NAME}_hu_HU.ts
@@ -80,13 +102,17 @@
     data/translations/${PROJECT_NAME}_tr_TR.ts
     data/translations/${PROJECT_NAME}_uk_UA.ts
     data/translations/${PROJECT_NAME}_zh_CN.ts
+    data/translations/${PROJECT_NAME}_zh_TW.ts
 )
 
-qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
+if(USE_QT5)
+    qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
+else()
+    qt6_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
+endif()
 
 add_executable(${PROJECT_NAME}
     ${QM_FILES}
-    data/icons/flags/flags.qrc
     ${HelperInterface_SRCS}
     src/main.cpp
     src/mainwindow.h
@@ -112,8 +138,7 @@
 
 target_link_libraries(${PROJECT_NAME} PRIVATE
     SingleApplication::SingleApplication
-    Qt5::Widgets
-    Qt5::DBus
+    ${QT_LIBS}
 )
 
 set(APP_ICONS
@@ -140,8 +165,8 @@
 )
 
 target_link_libraries(${PROJECT_NAME}_helper
-    Qt5::DBus
-    PolkitQt5-1::Core
+    ${QT_LIBS}
+    ${POLKIT_LIB}
 )
 
 install(TARGETS ${PROJECT_NAME}_helper DESTINATION ${KDE_INSTALL_LIBEXECDIR})

=== debian/control ===
Source: kdiskmark
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Dmitry Ilyich Sidorov <jonmagon@gmail.com>
Uploaders: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               extra-cmake-modules,
               libaio-dev,
               libpolkit-qt5-1-dev,
               qttools5-dev
Standards-Version: 4.7.0
Homepage: https://github.com/JonMagon/KDiskMark
Vcs-Browser: https://salsa.debian.org/debian/kdiskmark
Vcs-Git: https://salsa.debian.org/debian/kdiskmark.git

Package: kdiskmark
Architecture: any
Depends: fio, ${misc:Depends}, ${shlibs:Depends}
Description: simple disk benchmark tool
 This is an HDD and SSD benchmark tool with a very friendly
 graphical user interface. KDiskMark with its presets and powerful
 GUI calls Flexible I/O Tester and handles the output to provide a
 comprehensive benchmark result that's easy to view and interpret.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-D CMAKE_BUILD_TYPE=Release \
	-D USE_QT5=ON

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## kdiskmark 3.2.0+ds

=== debian/changelog ===
kdiskmark (3.2.0+ds-1) unstable; urgency=medium

  * New upstream version.
  * Bump standard version to 4.7.2.
  * d/copyright:
    - bump years.
    - drop data/icons/flags/* part.
  * d/control:
    - Rules-Requires-Root dropped.
    - qt5 to qt6, add libpolkit-qt6-1-dev to build-depends.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Wed, 10 Dec 2025 13:17:56 +0100

=== debian/control ===
Source: kdiskmark
Section: utils
Priority: optional
Maintainer: Dmitry Ilyich Sidorov <jonmagon@gmail.com>
Uploaders: Alex Myczko <tar@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 extra-cmake-modules,
 libaio-dev,
 qt6-base-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 libpolkit-qt6-1-dev,
Standards-Version: 4.7.2
Homepage: https://github.com/JonMagon/KDiskMark
Vcs-Browser: https://salsa.debian.org/debian/kdiskmark
Vcs-Git: https://salsa.debian.org/debian/kdiskmark.git

Package: kdiskmark
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 fio,
Description: simple disk benchmark tool
 This is an HDD and SSD benchmark tool with a very friendly
 graphical user interface. KDiskMark with its presets and powerful
 GUI calls Flexible I/O Tester and handles the output to provide an
 easy to view and interpret comprehensive benchmark result.

=== debian/watch ===
Version: 5

# GitHub hosted projects.
Template: Github
Owner: JonMagon
Project: KDiskMark
